module Adminix
  module Entities
    class SysloadStamp

      attr_reader :memory_usage_mb, :cpu_load_percents, :disk_usage_mb,
                  :temperature, :created_at

      def initialize
        create_stamp
        @created_at = Time.now
      end

      def create_stamp
        case Adminix.os
        when 'linux'
          @memory_usage_mb, = Helpers::Command.debian_memory_load
          @cpu_load_percents = Helpers::Command.debian_cpu_load
          @disk_usage_mb, = Helpers::Command.debian_disk_usage
          @temperature = Helpers::Command.debian_temperature
        when 'mac'
          @cpu_load_percents = Helpers::Command.darwin_cpu_load
          @disk_usage_mb, = Helpers::Command.darwin_disk_usage
        end
      end

      def to_api
        {
          memory: memory_usage_mb,
          cpu: cpu_load_percents,
          disk: disk_usage_mb,
          temperature: temperature,
          created_at: created_at
        }
      end
    end
  end
end
